<?php
/**
 * Copyright (C) 2006 Google Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Please refer to the Google Checkout PHP Sample Code Documentation
 * for requirements and guidelines on how to use the sample code.
 * 
 * This sample code is a simple listener for the responses that the 
 * Google Checkout server sends to the merchants. When a response is 
 * received, it logs the message to a local file and processes the message.
 *
 * Google Checkout server using HTML (name/value pairs)
 *
 */
 
 // running time (for calculate prorata use)
$current_time = time();
 
include_once ("..\\local\\transaction.php"); //\\ - 20120820 - Redirect path to transaction.php

	$myTxn = new transaction();

	//copy $_POST for validation
	foreach ($_POST as $key => $val){
	  $postfields[strtolower($key)] = $val;
  	}

	$message_recognizer =  $_POST['_type'];
	$googleTxnNum = $_POST['google-order-number'];

if ($message_recognizer=="new-order-notification"){
	
	if (!isset($_POST["shopping-cart_merchant-private-data"])) {
	  $log = date('l dS \of F Y h:i:s A')." - undefine invoice number.\r\n\r\n";
	  foreach ( $_POST as $key => $val )
	    	$log .= "$key = $val\r\n";
	  $log .= "\r\n";
	  $myTxn->writeLog("..\\log\\txn.log", $log);
	  die;
	}
	
	// 10-03-2010 change meaning of "shopping-cart_merchant-private-data" (invoice and psot time)
	if (isset($_POST["shopping-cart_merchant-private-data"])){
		list($invoice_no, $post_time) = explode("|", $_POST["shopping-cart_merchant-private-data"]);
	}
  
	  if (isset($post_time) && $post_time >0){
		$withinDay = false;
		$curr_localtime  = localtime($current_time, true);
		$post_localtime  = localtime($post_time, true);
		// compare the running time within a day
		if ($curr_localtime['tm_year'] == $post_localtime['tm_year'] && $curr_localtime['tm_yday'] == $post_localtime['tm_yday']){ // compare year and Day of the year 
			$withinDay = true;
		}
		if ($withinDay == false) { // not at the same day
			$log .= date('l dS \of F Y h:i:s A')." - Transaction (between submit and notification) not at the same day, it will affect calculate price with prorata\r\n";
			$valid_txn = false;
			foreach ( $_POST as $key => $val )
				$log .= "$key = $val\r\n";
		  $log .= "\r\n";
		  $myTxn->writeLog("..\\log\\txn.log", $log);
		  die;
		}
	  }
	
    // 20070809 - Add item name
	$invoice = $invoice_no;
	$subscrdate = $_POST["timestamp"];
	$email = $_POST["buyer-billing-address_email"];
	$buyer_id = $_POST["buyer-id"];
    $item_name = $_POST["shopping-cart_items_item-1_item-name"];
	
	// 20090708 - Add field type array
    // 20070809 - Add item name
	$updateTxn = new transaction();
	$txn_fields=array();	
	$bFieldNumeric = array();
	$txn_fields['TXN_ID'] = $googleTxnNum;
	$bFieldNumeric['TXN_ID'] = 0;
	$txn_fields['SUBSCRDATE'] = $subscrdate;
	$bFieldNumeric['SUBSCRDATE'] = 0;
	$txn_fields['PAYEREMAIL'] = $email;
	$bFieldNumeric['PAYEREMAIL'] = 0;
	$txn_fields['PAYER_ID'] = $buyer_id;
	$bFieldNumeric['PAYER_ID'] = 0;
    $txn_fields['ITEM_NAME'] = $item_name;
    $bFieldNumeric['ITEM_NAME'] = 0;
		
	$updateTxn->update_transaction($invoice, $txn_fields, $bFieldNumeric);
}else if ($message_recognizer=="charge-amount-notification"){
	$googleCharge = $_POST["total-charge-amount"];
	$paydate = $_POST["timestamp"];
	
	// 10-03-2010 change meaning of "shopping-cart_merchant-private-data" (invoice and psot time)
	if (isset($_POST["shopping-cart_merchant-private-data"])){
		list($invoice_no, $post_time) = explode("|", $_POST["shopping-cart_merchant-private-data"]);
	}
	
	$settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
	$txn_table=$settingobj->getKey( "Datasource_PayPal_Table", "gateway");
    //release COM object
    //$settingobj->Release();
    $settingobj=null;
	
    // 20070809 - Add item name
	$updateTxn = new transaction();
	$myDB = new db();
	$q="SELECT * FROM $txn_table WHERE TXN_ID='$googleTxnNum'";
	$result=$myDB->query($q);
	$username = odbc_result($result, 'username');		
	$plan = odbc_result($result, 'planname');		
	$invoice = odbc_result($result, 'invoice');		
	$amount = odbc_result($result, 'amount');		
    $item_name = odbc_result($result, 'item_name');
		
	// 20090708 - Add field type array
	$txn_fields=array();	
	$bFieldNumeric = array();
	$txn_fields['pay_status'] = "completed";
	$bFieldNumeric['pay_status'] = 0;
	$txn_fields['pay_date'] = $paydate;
	$bFieldNumeric['pay_date'] = 0;

    // 20071116 - Enhance log messages
    // 20071114 - Set error flag
    // 20070807 - Validate if transacted amount matches with the plan
    $payErrFlag = false;
	$pureGross = 0;
    if ($googleCharge == $amount){
	if (isset($item_name) && isset($googleCharge)) {
		$pureGross = $googleCharge;
		
		if (isset($post_time) && $post_time > 0){ // >0: using item attribute and set monthly pass
			$cart_item_arr = null;
			$cart_item_arr = $myTxn->get_cart_item_arr_by_desc($item_name);
			if($cart_item_arr!=null){
				$base_time = 0;
				$u_expire_month = 0;

				if ($username != ""){
					$u_expire_month = fs_expire_month_utime($username); // get user expire month (unix timestamp format)
				}

				if ( $current_time > $u_expire_month || $u_expire_month == false) // emonth eyear field is null or expired
					$base_time = $current_time;
				else
					$base_time = $u_expire_month;
					
				if ($cart_item_arr['useMethod'] == 1&& isset($cart_item_arr['item_attr']['topup']) && $cart_item_arr['item_attr']['topup'] >0){ // uisng item attribute and set monthly pass
					// calculate price with prorata
					$p_price = fs_cal_price_with_prorata($base_time, $cart_item_arr["amount"], $cart_item_arr["item_attr"]["topup"], 2);
					
					$pureGross = $pureGross + ($cart_item_arr["amount"] - $p_price);
				}
				else{
				}
			}
		}
		
	    $vRC = $updateTxn->ValidateCart($item_name, $pureGross);
	    if ($vRC == -1) {
		$txn_fields['pay_status'] = "Failed";
		$payErrFlag = -2;
	    } elseif ($vRC == -2) {
		$txn_fields['pay_status'] = "Failed";
		$payErrFlag = -3;
	    }
	} else {
	    $txn_fields['pay_status'] = "Failed";
	    $payErrFlag = -1;
	}
		$updateTxn->update_transaction($invoice, $txn_fields, $bFieldNumeric);

	if (strtolower($txn_fields["pay_status"]) == "completed") {
	
		if (!isset($plan) || $plan =='')
			$myTxn->update_usr_table_by_item_attr($username, $item_name, $post_time); //\\ - 20120820 - Debug : wrong data name
		else
			$myTxn->update_usr_table($username, $plan);
		
	    $log = date('l dS \of F Y h:i:s A')." - $username account has been updated!\r\n";
	} else {
	    if ($payErrFlag == -1) {
		$log = date('l dS \of F Y h:i:s A')." - Fail to update $username account due to insufficient payment information!\r\n";
	    } elseif ($payErrFlag == -2) {
		$log = date('l dS \of F Y h:i:s A')." - Fail to update $username account due to chosen shopping item does not exist!\r\n";
	    } elseif ($payErrFlag == -3) {
		$log = date('l dS \of F Y h:i:s A')." - Fail to update $username account due to payment amount mismatch!\r\n";
	    } else {
		$log = date('l dS \of F Y h:i:s A')." - Fail to update $username account!\r\n";
	    }

	    // 20071114 - Print all postfields for investigation
	    foreach ($_POST as $key => $val) {
		$log .= "$key = $val\r\n";
	    }
	    $log .= "\r\n";
	}
    }else{
	// 20071116 - Update DB
	$txn_fields['pay_status'] = "Failed";
		$updateTxn->update_transaction($invoice, $txn_fields, $bFieldNumeric);

	$log = date('l dS \of F Y h:i:s A')." - $username 's googleCharge does not match the amount !\r\n";
	foreach ( $_POST as $key => $val )
	$log .= "$key = $val\r\n";
	$log .= "\r\n";  
    }
    $updateTxn->writeLog("..\\log\\txn.log", $log);

}else if ($message_recognizer=="refund-amount-notification"){
	$googleCharge = $_POST["total-refund-amount"];
	$paydate = $_POST["timestamp"];
	$currency = $_POST["total-refund-amount_currency"];
	
	// 10-03-2010 change meaning of "shopping-cart_merchant-private-data" (invoice and psot time)
	if (isset($_POST["shopping-cart_merchant-private-data"])){
		list($invoice_no, $post_time) = explode("|", $_POST["shopping-cart_merchant-private-data"]);
	}
	
	$settingobj = new COM("FSCONFIG.Cfgmgr") or die("common_functions.php FSCONFIG.Cfgmgr Object cannot be created!");
	$txn_table=$settingobj->getKey( "Datasource_PayPal_Table", "gateway");
    //release COM object
    //$settingobj->Release();
    $settingobj=null;
	
    // 20070809 - Add item name
	$updateTxn = new transaction();
	$myDB = new db();
	$q="SELECT * FROM $txn_table WHERE TXN_ID='$googleTxnNum'";
	$result=$myDB->query($q);
	$username = odbc_result($result, 'username');
	$plan = odbc_result($result, 'planname');		
	$invoice = odbc_result($result, 'invoice');		
	$amount = odbc_result($result, 'amount');		
    $item_name = odbc_result($result, 'item_name');
		
	// 20090708 - Add field type array
	$txn_fields=array();	
	$bFieldNumeric = array();
	$txn_fields['pay_status'] = "Refunded";
	$bFieldNumeric['pay_status'] = 0;
	$txn_fields['pay_date'] = $paydate;
	$bFieldNumeric['pay_date'] = 0;
	
	$pureGross = 0;
	
    // 20070807 - Validate if transacted amount matches with the plan
    if (isset($item_name) && isset($googleCharge)) {
		
		$pureGross = $googleCharge;
	
		if (isset($post_time) && $post_time > 0){ // >0: using item attribute and set monthly pass
			$cart_item_arr = null;
			$cart_item_arr = $myTxn->get_cart_item_arr_by_desc($item_name);
			if($cart_item_arr!=null){
				$base_time = 0;
				$u_expire_month = 0;

				if ($username != ""){
					$u_expire_month = fs_expire_month_utime($username); // get user expire month (unix timestamp format)
				}

				if ( $current_time > $u_expire_month || $u_expire_month == false) // emonth eyear field is null or expired
					$base_time = $current_time;
				else
					$base_time = $u_expire_month;
					
				if ($cart_item_arr['useMethod'] == 1&& isset($cart_item_arr['item_attr']['topup']) && $cart_item_arr['item_attr']['topup'] >0){ // uisng item attribute and set monthly pass
					// calculate price with prorata
					$p_price = fs_cal_price_with_prorata($base_time, $cart_item_arr["amount"], $cart_item_arr["item_attr"]["topup"], 2);
					
					$pureGross = $pureGross + ($cart_item_arr["amount"] - $p_price);
				}
				else{
				}
			}
		}
		
		if (!$updateTxn->ValidateCart($item_name, $pureGross)) {
			$txn_fields['pay_status'] = "Failed";
		}
    } else {
	$txn_fields['pay_status'] = "Failed";
    }
		$updateTxn->update_transaction($invoice, $txn_fields, $bFieldNumeric);
    if (strtolower($txn_fields["pay_status"]) == "refunded") {
	$log = date('l dS \of F Y h:i:s A')." - $username account has been refunded  $currency $googleCharge !\r\n";
    } else {
	$log = date('l dS \of F Y h:i:s A')." - Fail to refund $currency $googleCharge to $username account!\r\n";
    }
    $updateTxn->writeLog("..\\log\\txn.log", $log);

}else if ($message_recognizer=="risk-information-notification"){
	// provide financial information that helps you to ensure that an order is not fraudulent
}else if ($message_recognizer=="order-state-change-notification"){
	// notify you that an order's financial status or its fulfillment status has changed
}else{
	$log = "-----------------Receive---------------\r\n";
	foreach ($_POST as $key => $val)
	  $log .= $key." = ".$val."\r\n";
    
    $log .= "-----------------End-----------------------\r\n";
    $myTxn->writeLog("..\\log\\txn.log", $log);
}
?>
