<?php

// 20090430 - Handle URL log retrieving

set_time_limit(0);

include ("secureLogin.php");
include_once ("..\\authserv\\common_functions.php");
// create COM object
$settingObj		= new COM('FSCONFIG.Cfgmgr') or die ('urllog_entry.php FSCONFIG.Cfgmgr Object cannot be created!');
$isAnony		= $settingObj->getKey('anonymous_login', 'gateway');
$showSrcPort	= ($settingObj->getKey('showSrcPort', 'URLTracking')!=0);
$settingObj		= null;

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>URL Log Entry</title>
<style type="text/css">
	table {
		font-family: Arial, sans-serif;
		font-size: 8pt;
	}
</style>
<script type="text/javascript" src="./javascript/loadingBox.js"></script>
<script type="text/javascript" src="./javascript/url_log.js"></script>
</head>
<body>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<?php

$type = 'date_range';
$num = 500;
$start_date = mktime(0, 0, 0, date('n'), date('j'), date('Y'));
$start_date = '0';
$end_date = mktime(0, 0, 0, date('n'), date('j'), date('Y')) + 86400;

if (isset($_GET['type'])) {
	$type = $_GET['type'];
	if ($type == 'most_recent') {
		$num = $_GET['num'];
	} else {
		$treatStartDate = explode('-', $_GET['start']);
		if (!checkdate($treatStartDate[1], $treatStartDate[2], $treatStartDate[0])) {
			exit('start date not exist');
		}
		$start_date = mktime(0, 0, 0, $treatStartDate[1], $treatStartDate[2], $treatStartDate[0]);

		$treatEndDate = explode('-', $_GET['end']);
		if (!checkdate($treatEndDate[1], $treatEndDate[2], $treatEndDate[0])) {
			exit('end date not exist');
		}
		$end_date = mktime(0, 0, 0, $treatEndDate[1], $treatEndDate[2], $treatEndDate[0]) + 86400;
	}
}

$logDirArr = array("..\\log\\archive", "..\\log");
$csvPrfx = 'urltracking_';
$csvSufx = '.csv';
$csvArr = array();
$cnt = 0;

$matcher = "/^".$csvPrfx.'[0-9]{4}(.[0-9]{2}){2}_[0-9]{2}(.[0-9]{2}){2}'.$csvSufx.'$/';

// Extract full path of the CSV files
foreach ($logDirArr as $l) {
	$fileArr = scandir($l);
	foreach ($fileArr as $f) {
		$filePath = "$l\\$f";
//		if (is_file($filePath) && ereg('^'.$csvPrfx.'[0-9]{4}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}[_]{1}[0-9]{2}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}'.$csvSufx.'$', $f)) {
		if (is_file($filePath) && preg_match($matcher, $f)) {
			$treatFilePath = str_replace($csvSufx, '', $filePath);
			$getPos = strpos($treatFilePath, $csvPrfx, 1) + strlen($csvPrfx);
			if (strpos(substr($treatFilePath, $getPos, strlen($treatFilePath) - $getPos), '_') >0){
				$fileDate = explode('_', substr($treatFilePath, $getPos, strlen($treatFilePath) - $getPos));
				$dateArray = explode('.', $fileDate[0]);
				$timeArray = explode('.', $fileDate[1]);
				$dateTimeStamp = mktime($timeArray[0], $timeArray[1], $timeArray[2], $dateArray[1], $dateArray[2], $dateArray[0]);
				$csvArr[$dateTimeStamp] = $filePath;
			}
		}
	}
}
krsort($csvArr);

// Read CSV files one by one
$count = 0;
$shown = 0;
$previous_timestamp = 9999999999;
foreach ($csvArr as $timestamp => $c){
	$dataArray = array();
	if ($type == 'date_range' && ($timestamp >= $end_date || $previous_timestamp <= $start_date)) {
		continue;
	}
	if ($num == 0) break;
	$fp = fopen($c, 'rt');
	if ($type == 'most_recent') {
		$seekStartFrom = filesize($c) - (150 * ($num - $count));
		if ($seekStartFrom >= 0)
			fseek($fp, $seekStartFrom);
	}
	if ($fp != FALSE) {
		$meetTitle = 0;
		// 20090302 - Show port numbers for non-well-known protocols
		// 20090106 - Retrieve destination port and convert to protocol if possible
		while (($dataArr = fgetcsv($fp, 512, ',', "'")) !== FALSE) {
			// Skip the title line
			if ($meetTitle == 0)
			{
				$meetTitle = 1;
				continue;
			}
			if (count($dataArr) != 8 && count($dataArr) != 9) {
				continue;
			}
			if ($num == 0) break;

			if ($type == 'date_range' && $dataArr[5] >= $start_date && $dataArr[5] <= $end_date) {
				logShowData($dataArr);
			} else if ($type == 'most_recent') {
				$dataArray[] = $dataArr;
				$count++;
			}
		}

		fclose($fp);
	}

	if ($type == 'most_recent' && $count > $num) {
		krsort($dataArray);
		foreach ($dataArray as $dataArr) {
			if ($shown >= $num) break;
			$shown++;
			logShowData($dataArr);
		}
		break;
	} else {
		krsort($dataArray);
		foreach ($dataArray as $dataArr) {
			$shown++;
			logShowData($dataArr);
		}
	}
	$previous_timestamp = $timestamp;
}

function logShowData($dataArr) {
	global $showSrcPort;
	$name = $dataArr[0];
	$logintime = $dataArr[1];
	$MacAddr = $dataArr[2];
	if($showSrcPort && isset($dataArr[8]))
		$IPAddr = $dataArr[3].':'.$dataArr[8];
	else
		$IPAddr = $dataArr[3];
	$url = $dataArr[4];
	$loginTimeInt = $dataArr[5];
	$DestipAddr = $dataArr[6];
	$destPort = (int)$dataArr[7];

	$tok = strtok($MacAddr, ':');
	$i = 0;
	$mac[$i++] = $tok;

	while ($tok) {
		$tok = strtok(':');
		$mac[$i++] = $tok;
	}

	$MacAddr = $mac[0].'-'.$mac[1].'-'.$mac[2].'-'.$mac[3].'-'.$mac[4].'-'.$mac[5];

	switch ($destPort) {
		case 20:
		case 21:
			$protocol = 'FTP';
			break;
		case 23:
			$protocol = 'Telnet';
			break;
		case 25:
			$protocol = 'SMTP';
			break;
		case 53:
			$protocol = 'DNS';
			break;
		case 67:
		case 68:
			$protocol = 'DHCP';
			break;
		case 80:
			$protocol = 'HTTP';
			break;
		case 110:
			$protocol = 'POP3';
			break;
		case 443:
			$protocol = 'SSL';
			break;
		case 995:
			$protocol = 'POP3S';
			break;
		default:
			$protocol = $destPort;
	}

?>
	<tr onMouseOut="HighlightRow(this, 0)" onMouseOver="HighlightRow(this, 1)">
		<?php if (!strtolower($GLOBALS['isAnony'] == 'on')) { ?>
			<td width="18%"><?=$name?></td>
		<?php } ?>
		<td width="16%"><?=$logintime?></td>
		<td width="12%"><?=$MacAddr?></td>
		<td width="12%"><?=$IPAddr?></td>
		<td width="8%"><?=$protocol?></td>
		<td width="12%"><?=$DestipAddr?></td>
		<td width="22%"><?=$url?></td>
		<script>
			SetExtraInfo(<?=$GLOBALS['cnt']++?>, 'loginTimeInt', "<?=$loginTimeInt?>");
		</script>
	</tr>
<?php

}

?>
</table>
<script type="text/javascript">
	CallParentLoadingBox(false, false);
</script>
</body>
</html>
